<?php namespace App\Models;

use CodeIgniter\Model;

class DevManageModel extends Model
{
    protected $DBGroup = 'default';                               //默认连接的数据库
    protected $table      = 'first_category';                     //指定模型要使用的数据库表
    protected $returnType     = 'array';

    protected $allowedFields = [                                 //允许更改，写入数据库的字段
        "category_name",
        "detail",
        "create_time",
        "first_category_id",
    ];

///////////////////////////////////////////////////  分类管理区域  ////////////////////////////////////////////////////////////////
    /****************************************************
     *       向第一分类表插入数据
     /****************************************************/
    public function insertFirstCategoryData($data){
        $maxIdObj = $this->db->query('select Max(id) AS id from first_category');
        $maxIdResult = $maxIdObj->getResultArray();
        $id = $maxIdResult[0]["id"] + 1;
        $sql = 'insert into first_category (id,category_name,detail,create_time) values ("'.$id.'","'
        .$data["category_name"].'","'
        .$data["detail"].'","'
        .$data["create_time"].'")';
        $insertObj = $this->db->query($sql);
    }

    /****************************************************
     *       编辑一级分类
     /****************************************************/
     public function editFirstCategoryData($data){
        $sql = 'update first_category set ';
        $isAdd = 0;
        if(array_key_exists("category_name",$data)){
            if($isAdd == 0){
                $sql = $sql.'category_name="'.$data["category_name"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',category_name="'.$data["category_name"].'"';
            }
        }
        if(array_key_exists("detail",$data)){
            if($isAdd == 0){
                $sql = $sql.'detail="'.$data["detail"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',detail="'.$data["detail"].'"';
            }
        }
        if(array_key_exists("edit_time",$data)){
            if($isAdd == 0){
                $sql = $sql.'edit_time="'.$data["edit_time"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',edit_time="'.$data["edit_time"].'"';
            }
        }
        $sql = $sql.' where id='.$data["category_id"].'';
        $obj = $this->db->query($sql);
     }

    /****************************************************
     *       删除一条第一分类数据
     /****************************************************/
     public function delFirstCategoryById($id){
        $sql = "delete from second_category where first_category_id=".$id;
        $this->db->query($sql);
        $sql = "delete from first_category where id=".$id;
        $this->db->query($sql);
     }

    /****************************************************
     *       删除一条第二级分类数据
     /****************************************************/
     public function delSecondCategoryById($id){
        $sql = "delete from second_category where id=".$id;
        $this->db->query($sql);
     }

    /****************************************************
     *       向第二分类表插入数据
     /****************************************************/
    public function insertSecondCategoryData($data){
        $sql = 'insert into second_category (category_name,detail,first_category_id,create_time) values ("'
        .$data["category_name"].'","'
        .$data["detail"].'","'
        .$data["first_category_id"].'","'
        .$data["create_time"].'")';
        $insertObj = $this->db->query($sql);
    }

    /****************************************************
     *       编辑二级分类
     /****************************************************/
     public function editSecondCategoryData($data){
        $sql = 'update second_category set ';
        $isAdd = 0;
        if(array_key_exists("category_name",$data)){
            if($isAdd == 0){
                $sql = $sql.'category_name="'.$data["category_name"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',category_name="'.$data["category_name"].'"';
            }
        }
        if(array_key_exists("detail",$data)){
            if($isAdd == 0){
                $sql = $sql.'detail="'.$data["detail"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',detail="'.$data["detail"].'"';
            }
        }
        if(array_key_exists("edit_time",$data)){
            if($isAdd == 0){
                $sql = $sql.'edit_time="'.$data["edit_time"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',edit_time="'.$data["edit_time"].'"';
            }
        }
        $sql = $sql.' where id='.$data["category_id"].'';
        $obj = $this->db->query($sql);
     }

    /****************************************************
     *       获取第一级分类表的所有数据
     /****************************************************/
    public function getAllFirstCategory(){
         $sql = "select * from first_category";
         $allFirstCategoryObj = $this->db->query($sql);
         $result = $allFirstCategoryObj->getResultArray();
         return $result;
     }

    /****************************************************
     *       获取第二级分类表的数据通过一级分类id
     /****************************************************/
    public function getSecondCategoryByFirstCategoryId($firstCategoryId=1){
        $sql = "select * from second_category where first_category_id='".$firstCategoryId."'";
        $allFirstCategoryObj = $this->db->query($sql);
        $result = $allFirstCategoryObj->getResultArray();
        return $result;
    }

///////////////////////////////////////////////////  设备管理区域  ////////////////////////////////////////////////////////////////
    /****************************************************
     *       插入一条设备
     /****************************************************/
     public function insertDevice($data){
         $sql = 'insert into devices (dev_name, dev_code, dev_brand, dev_model, dev_system,
         dev_version, dev_color, add_time, dev_status, dev_delete, first_category_id, second_category_id,
         org_section_id, dev_detail, dev_feature) values ("'
         .$data["dev_name"].'","'
         .$data["dev_code"].'","'
         .$data["dev_brand"].'","'
         .$data["dev_model"].'","'
         .$data["dev_system"].'","'
         .$data["dev_version"].'","'
         .$data["dev_color"].'","'
         .$data["add_time"].'",'
         .$data["dev_status"].','
         .$data["dev_delete"].','
         .$data["first_category_id"].','
         .$data["second_category_id"].','
         .$data["org_section_id"].',"'
         .$data["dev_detail"].'","'
         .$data["dev_feature"].'")';

         $insertObj = $this->db->query($sql);
     }

    /****************************************************
     *       更新设备信息(信息全部写入)
     /****************************************************/
     public function updateDevice($data){
        $sql = 'update devices set dev_name="'
        .$data["dev_name"].'",dev_code="'
        .$data["dev_code"].'",dev_brand="'
        .$data["dev_brand"].'",dev_model="'
        .$data["dev_model"].'",dev_system="'
        .$data["dev_system"].'",dev_version="'
        .$data["dev_version"].'",dev_color="'
        .$data["dev_color"].'",update_time="'
        .$data["update_time"].'",dev_status='
        .$data["dev_status"].',dev_delete='
        .$data["dev_delete"].',first_category_id='
        .$data["first_category_id"].',second_category_id='
        .$data["second_category_id"].',org_section_id='
        .$data["org_section_id"].',dev_detail="'
        .$data["dev_detail"].'",dev_feature="'
        .$data["dev_feature"].'"'
        .' where id="'.$data["id"].'"';
        $obj = $this->db->query($sql);
    }

    /****************************************************
     *       更新设备指定信息（只针对改动的信息其中的一条信息）
     /****************************************************/
     public function updateTheDeviceInfo($data){
        $sql = 'update devices set ';
        if(array_key_exists("dev_name",$data)){
            $sql = $sql.'dev_name="'.$data["dev_name"].'",';
        }else if(array_key_exists("dev_code",$data)){
            $sql = $sql.'dev_code="'.$data["dev_code"].'",';
        }else if(array_key_exists("dev_brand",$data)){
            $sql = $sql.'dev_brand="'.$data["dev_brand"].'",';
        }else if(array_key_exists("dev_model",$data)){
            $sql = $sql.'dev_model="'.$data["dev_model"].'",';
        }else if(array_key_exists("dev_system",$data)){
            $sql = $sql.'dev_system="'.$data["dev_system"].'",';
        }else if(array_key_exists("dev_version",$data)){
            $sql = $sql.'dev_version="'.$data["dev_version"].'",';
        }else if(array_key_exists("dev_color",$data)){
            $sql = $sql.'dev_color="'.$data["dev_color"].'",';
        }else if(array_key_exists("update_time",$data)){
            $sql = $sql.'update_time="'.$data["update_time"].'",';
        }else if(array_key_exists("dev_status",$data)){
            $sql = $sql.'dev_status='.$data["dev_status"].',';
        }else if(array_key_exists("dev_delete",$data)){
            $sql = $sql.'dev_delete='.$data["dev_delete"].',';
        }else if(array_key_exists("first_category_id",$data)){
            $sql = $sql.'first_category_id='.$data["first_category_id"].',';
        }else if(array_key_exists("second_category_id",$data)){
            $sql = $sql.'second_category_id='.$data["second_category_id"].',';
        }else if(array_key_exists("org_section_id",$data)){
            $sql = $sql.'org_section_id='.$data["org_section_id"].',';
        }else if(array_key_exists("dev_detail",$data)){
            $sql = $sql.'dev_detail="'.$data["dev_detail"].'",';
        }else if(array_key_exists("dev_feature",$data)){
            $sql = $sql.'dev_feature="'.$data["dev_feature"].'",';
        }else if(array_key_exists("borrow_id",$data)){
            $sql = $sql.'borrow_id='.$data["borrow_id"];
        }
        $sql = $sql.' where id="'.$data["id"].'"';
        $obj = $this->db->query($sql);
    }

    /****************************************************
     *       更新设备指定信息（只针对改动的信息）
     /****************************************************/
     public function updateTheDeviceInfo2($data){
        $sql = 'update devices set ';
        $isAdd = 0;
        if(array_key_exists("dev_name",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_name="'.$data["dev_name"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_name="'.$data["dev_name"].'"';
            }
        }
        if(array_key_exists("dev_code",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_code="'.$data["dev_code"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_code="'.$data["dev_code"].'"';
            }
        }
        if(array_key_exists("dev_brand",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_brand="'.$data["dev_brand"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_brand="'.$data["dev_brand"].'"';
            }
        }
        if(array_key_exists("dev_model",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_model="'.$data["dev_model"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_model="'.$data["dev_model"].'"';
            }
        }
        if(array_key_exists("dev_system",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_system="'.$data["dev_system"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_system="'.$data["dev_system"].'"';
            }
        }
        if(array_key_exists("dev_version",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_version="'.$data["dev_version"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_version="'.$data["dev_version"].'"';
            }
        }
        if(array_key_exists("dev_color",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_color="'.$data["dev_color"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_color="'.$data["dev_color"].'"';
            }
        }else if(array_key_exists("update_time",$data)){
            if($isAdd == 0){
                $sql = $sql.'update_time="'.$data["update_time"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',update_time="'.$data["update_time"].'"';
            }
        }
        if(array_key_exists("dev_status",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_status='.$data["dev_status"].'';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_status='.$data["dev_status"].'';
            }
        }if(array_key_exists("dev_delete",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_delete='.$data["dev_delete"].'';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_delete='.$data["dev_delete"].'';
            }
        }if(array_key_exists("first_category_id",$data)){
            if($isAdd == 0){
                $sql = $sql.'first_category_id='.$data["first_category_id"].'';
                $isAdd = 1;
            }else{
                $sql = $sql.',first_category_id='.$data["first_category_id"].'';
            }
        }
        if(array_key_exists("second_category_id",$data)){
            if($isAdd == 0){
                $sql = $sql.'second_category_id='.$data["second_category_id"].'';
                $isAdd = 1;
            }else{
                $sql = $sql.',second_category_id='.$data["second_category_id"].'';
            }
        }
        if(array_key_exists("org_section_id",$data)){
            if($isAdd == 0){
                $sql = $sql.'org_section_id='.$data["org_section_id"].'';
                $isAdd = 1;
            }else{
                $sql = $sql.',org_section_id='.$data["org_section_id"].'';
            }
        }
        if(array_key_exists("dev_detail",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_detail="'.$data["dev_detail"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_detail="'.$data["dev_detail"].'"';
            }
        }
        if(array_key_exists("dev_feature",$data)){
            if($isAdd == 0){
                $sql = $sql.'dev_feature="'.$data["dev_feature"].'"';
                $isAdd = 1;
            }else{
                $sql = $sql.',dev_feature="'.$data["dev_feature"].'"';
            }
        }
        if(array_key_exists("borrow_id",$data)){
            if($isAdd == 0){
                $sql = $sql.'borrow_id='.$data["borrow_id"];
                $isAdd = 1;
            }else{
                $sql = $sql.',borrow_id='.$data["borrow_id"];
            }
        }
        $sql = $sql.' where id="'.$data["id"].'"';
        $obj = $this->db->query($sql);
    }

    /****************************************************
     *       分页获取设备信息
     /****************************************************/
     public function getDevicesAllInfoByPage($data){
        $sql = 'select t1.*,
        t2.category_name,
        t3.org_section_name,
        t4.id as borrow_id,t4.borrower,t4.user_id,t4.borrow_status
        from devices t1 
        left join first_category  t2 on t1.first_category_id = t2.id
        left join org_section t3 on t1.org_section_id = t3.id
        left join dev_borrow t4 on t1.borrow_id = t4.id limit '.(($data["page"] - 1) * $data["perPage"]).','.$data["perPage"];
        $allFirstCategoryObj = $this->db->query($sql);
        $result = $allFirstCategoryObj->getResultArray();
        return $result;
    }

    /****************************************************
     *       获取单条设备信息
     /****************************************************/
     public function getDeviceInfoById($id){
        $sql = 'select t1.*,
        t2.category_name,
        t3.org_section_name,
        t4.id as borrow_id,t4.borrower,t4.user_id,t4.borrow_status,t4.borrow_time
        from devices t1 
        left join first_category  t2 on t1.first_category_id = t2.id
        left join org_section t3 on t1.org_section_id = t3.id 
        left join dev_borrow t4 on t1.borrow_id = t4.id where t1.id='.$id;
        $allFirstCategoryObj = $this->db->query($sql);
        $result = $allFirstCategoryObj->getResultArray();
        return $result;
    }

    /****************************************************
     *       获取所有的设备数
     /****************************************************/
     public function getTatalDeviceNum(){
        $sql = 'select count(*) as total from devices';
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       获取单条设备信息
     /****************************************************/
     public function getDevInfoById($id){
        $sql = "select * from devices where id=".$id;
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       删除设备
     /****************************************************/
     public function delDevById($id){
        $sql = "delete from devices where id=".$id;
        $this->db->query($sql);
    }

///////////////////////////////////////////////////  图片操作区域  ////////////////////////////////////////////////////////////////
    /****************************************************
     *       添加设备图片
     /****************************************************/
     public function insertDevImg($data){
        $sql = 'insert into dev_img (dev_id,create_time,img_ori,img_small) values ('
        .$data["devId"].',"'
        .$data["create_time"].'","'
        .$data["img_ori"].'","'
        .$data["img_small"].'")';
        $this->db->query($sql);
    }

    /****************************************************
     *       根据设备id获取设备图片
     /****************************************************/
    public function getDevImgsById($id){
        $sql = "select * from dev_img where dev_id=".$id;
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
    }

    /****************************************************
     *       根据图片id获取设备图片信息
     /****************************************************/
     public function getImgInfoById($id){
        $sql = "select * from dev_img where id=".$id;
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
    }

    /****************************************************
     *       根据设备id删除指定设备图片
     /****************************************************/
     public function delImgByIds($data){
        $sql = "delete from dev_img where dev_id=".$data["dev_id"]." and id=".$data["img_id"];
        $this->db->query($sql);
    }

///////////////////////////////////////////////////  设备签借区域  ////////////////////////////////////////////////////////////////
    /****************************************************
     *       添加设备签借信息
     /****************************************************/
     public function insertBorrowInfo($data){
        $sql = 'insert into dev_borrow (dev_id,user_id,borrower,comment,borrow_time,borrow_status) values ('
        .$data["dev_id"].','
        .$data["user_id"].',"'
        .$data["borrower"].'","'
        .$data["comment"].'","'
        .$data["borrow_time"].'",'
        .$data["borrow_status"].')';
        $this->db->query($sql);
    }

    /****************************************************
     *       根据用户名和设备id查询签借信息
     /****************************************************/
     public function searchBorrowInfoByBorrowerAndDevid($data){
        $sql = 'select * from dev_borrow where borrower="'.$data["borrower"].'" and dev_id='.$data["dev_id"];
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

     /****************************************************
     *       根据设备id查询签借信息
     /****************************************************/
     public function searchBorrowerInfoByDevid($data){
        $sql = 'select * from dev_borrow where dev_id='.$data["dev_id"];
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

     /****************************************************
     *       根据设备id和设备状态查询签借信息
     /****************************************************/
     public function searchBorrowerInfoByDevidAndStatus($dev_id,$borrow_status){
        $sql = 'select * from dev_borrow where dev_id='.$dev_id.' and borrow_status='.$borrow_status;
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

     /****************************************************
     *       查询设备签借信息
     /****************************************************/
     public function getBorrowInfoByPage($data){
        $sql = 'select t1.*,
        t2.dev_name,t2.dev_code 
        from dev_borrow t1
        left join devices t2 on t1.dev_id = t2.id 
        where t1.borrow_status=1 limit '.(($data["page"] - 1) * $data["perPage"]).','.$data["perPage"];
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       获取所有的签借消息(未借出的设备)
     /****************************************************/
     public function getTatalBorrowNum(){
        $sql = 'select count(*) as total from dev_borrow where borrow_status=1';
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       删除签借消息通过消息id
     /****************************************************/
     public function deleteBorrowMsgById($id){
        $sql = "delete from dev_borrow where id=".$id;
        $this->db->query($sql);
     }

    /****************************************************
     *       删除指定设备id的所有签借消息
     /****************************************************/
     public function deleteBorrowMsgBydevid($id){
        $sql = "delete from dev_borrow where dev_id=".$id;
        $this->db->query($sql);
     }

    /****************************************************
     *       删除指定设备id的所有签借消息，除了指定的签借id
     /****************************************************/
     public function deleteBorrowMsgBydevidButId($data){
        $sql = "delete from dev_borrow where dev_id=".$data["dev_id"].' and id<>'.$data["borrow_id"];
        $this->db->query($sql);
     }

    /****************************************************
     *       修改签借状态
     /****************************************************/
     public function modifyBorrowStatus($data){
         $sql = 'update dev_borrow set borrow_status='.$data["borrow_status"]
         .',borrow_time="'.$data["borrow_time"].'"'
         .' where id='.$data["id"];
         $this->db->query($sql);
     }
}