<?php namespace App\Models;

use CodeIgniter\Model;

class UserManageModel extends Model
{
    protected $DBGroup = 'default';                               //默认连接的数据库
    protected $table      = 'users';                     //指定模型要使用的数据库表
    protected $returnType     = 'array';

    protected $allowedFields = [                                 //允许更改，写入数据库的字段
        "username",
        "nick",
        "password",
        "token",
        "status",
        "role",
        "create_time",
        "update_time",
        "login_time",
        "register_time",
        "org_section_id",
        "token",
        "token",
    ];

    /****************************************************
     *       获取所有用户
     /****************************************************/
     public function getAllUsers(){
        $sql = 'select t1.*,t2.org_section_name from users t1 left join org_section t2 on t1.org_section_id = t2.id';
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       分页获取用户数据
     /****************************************************/
     public function getUsersByPage($data){
        $sql = 'select t1.*,t2.org_section_name from users t1 left join org_section t2 on t1.org_section_id = t2.id'
        .' limit '.(($data["page"] - 1) * $data["perPage"]).','.$data["perPage"];
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       获取所有的用户数
     /****************************************************/
     public function getTatalUserNum(){
        $sql = 'select count(*) as total from users';
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

    /****************************************************
     *       添加用户
     /****************************************************/
     public function addUser($data){
        $sql = 'insert into users (username,nick,password,status,role,create_time,org_section_id) values ("'
        .$data["username"].'","'
        .$data["nick"].'","'
        .$data["password"].'",'
        .$data["status"].','
        .$data["role"].',"'
        .$data["create_time"].'",'
        .$data["org_section_id"].')';
        $this->db->query($sql);
    }

    /****************************************************
     *       更新用户信息
     /****************************************************/
     public function updateUserInfo($data){
         $sql = 'update users set username="'
         .$data["username"].'",nick="'
         .$data["nick"].'",password="'
         .$data["password"].'",status='
         .$data["status"].',role='
         .$data["role"].',update_time="'
         .$data["update_time"].'",org_section_id='
         .$data["org_section_id"]
         .' where id='.$data["id"];
         $this->db->query($sql);
     }

    /****************************************************
     *       删除用户
     /****************************************************/
     public function delUserById($id){
        $sql = "delete from users where id=".$id;
        $this->db->query($sql);
    }
    /****************************************************
     *       通过用户名搜索用户
     /****************************************************/
     public function selectUsersByUserName($data){
        $sql = 'select * from users where nick like "%'.$data["username"].'%"';
        $obj = $this->db->query($sql);
        $result = $obj->getResultArray();
        return $result;
     }

///////////////////////////////////////////////////  权限管理区域(目前没有权限表)  ////////////////////////////////////////////////////////////////
    /****************************************************
     *       获取所有权限类型
     /****************************************************/
     public function getAllRights(){

     }

}